export type ConfigurationController = {
    get: <T>(path: string) => Promise<T>;
    set: (path: string, value: string | boolean | number) => Promise<void>;
    clear: () => Promise<void>;
    write: () => Promise<void>;
};
export type LocalConfigurationFileName = 'usage_data_preferences.json';
/**
 * Instantiates LocalConfigurationController
 */
export declare class ConfigurationControllerFactory {
    private controllers;
    /**
     * initialized empty map of ConfigurationController;
     */
    constructor();
    /**
     * Returns a LocalConfigurationController
     */
    getInstance: (configFileName: LocalConfigurationFileName) => ConfigurationController;
}
export declare const configControllerFactory: ConfigurationControllerFactory;
//# sourceMappingURL=local_configuration_controller_factory.d.ts.map