/// <reference types="node" />
import { AccountIdFetcher } from './account_id_fetcher.js';
import { UsageDataEmitter } from './usage_data_emitter_factory.js';
import { AmplifyError } from '../index.js';
import { Dependency } from '@aws-amplify/plugin-types';
/**
 * Entry point for sending usage data metrics
 */
export declare class DefaultUsageDataEmitter implements UsageDataEmitter {
    private readonly libraryVersion;
    private readonly dependencies?;
    private readonly sessionUuid;
    private readonly url;
    private readonly accountIdFetcher;
    private dependenciesToReport?;
    /**
     * Constructor for UsageDataEmitter
     */
    constructor(libraryVersion: string, dependencies?: Dependency[] | undefined, sessionUuid?: string, url?: import("url").UrlWithStringQuery, accountIdFetcher?: AccountIdFetcher);
    emitSuccess: (metrics?: Record<string, number>, dimensions?: Record<string, string>) => Promise<void>;
    emitFailure: (error: AmplifyError, dimensions?: Record<string, string>) => Promise<void>;
    private getUsageData;
    private send;
    private translateMetricsToUsageData;
    private translateDimensionsToUsageData;
}
//# sourceMappingURL=usage_data_emitter.d.ts.map