import { AmplifyError } from '../index.js';
import { Dependency } from '@aws-amplify/plugin-types';
export type UsageDataEmitter = {
    emitSuccess: (metrics?: Record<string, number>, dimensions?: Record<string, string>) => Promise<void>;
    emitFailure: (error: AmplifyError, dimensions?: Record<string, string>) => Promise<void>;
};
/**
 * Creates UsageDataEmitter for a given library version
 */
export declare class UsageDataEmitterFactory {
    /**
     * Creates UsageDataEmitter for a given library version, usage data tracking preferences
     */
    getInstance: (libraryVersion: string, dependencies?: Array<Dependency>) => Promise<UsageDataEmitter>;
}
//# sourceMappingURL=usage_data_emitter_factory.d.ts.map