import { AppId, BackendIdentifier } from '@aws-amplify/plugin-types';
/**
 * Provides static methods for converting BackendIdentifier to parameter path strings
 */
export declare class ParameterPathConversions {
    /**
     * Convert a BackendIdentifier to a parameter prefix.
     */
    static toParameterPrefix(backendId: BackendIdentifier | AppId): string;
    /**
     * Convert a BackendIdentifier to a parameter full path.
     */
    static toParameterFullPath(backendId: BackendIdentifier | AppId, parameterName: string): string;
    /**
     * Generate an SSM path for references to other backend resources
     */
    static toResourceReferenceFullPath(backendId: BackendIdentifier, referenceName: string): string;
}
//# sourceMappingURL=parameter_path_conversions.d.ts.map